Bug 1075595 (ghc-transformers-compat) - Review Request: ghc-transformers-compat - A compatibility shim exposing the new types from transformers 0.3
Summary: Review Request: ghc-transformers-compat - A compatibility shim exposing the n...
Keywords:
Status: CLOSED ERRATA
Alias: ghc-transformers-compat
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jens Petersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: ghc-distributive 1094423 1116575
TreeView+ depends on / blocked
 
Reported: 2014-03-12 12:47 UTC by Rick Elrod
Modified: 2014-11-30 19:15 UTC (History)
4 users (show)

Fixed In Version: ghc-transformers-compat-0.3.3.4-2.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-07-30 21:56:45 UTC
petersen: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)
ghc-transformers-compat.spec-1.patch (1.19 KB, patch)
2014-07-07 09:36 UTC, Jens Petersen
no flags Details | Diff

Description Rick Elrod 2014-03-12 12:47:26 UTC
Spec URL: http://codeblock.fedorapeople.org/packages/ghc-transformers-compat/ghc-transformers-compat.spec
SRPM URL: http://codeblock.fedorapeople.org/packages/ghc-transformers-compat/ghc-transformers-compat-0.1.1.1-1.fc20.src.rpm
Description: 
This package includes backported versions of types that were added to
transformers in transformers 0.3 for users who need strict transformers 0.2
compatibility to run on old versions of the platform, but also need those
types.

Fedora Account System Username: codeblock

Comment 1 Jens Petersen 2014-03-17 02:04:54 UTC
I am happy to review this: we discussed with the author about
allowing revdeps to depend instead on transformers-0.3 but 
he felt it is still too early for the whole Haskell library eco-system
(he will probably wait after HP 2014.4).

However I think (untested;) it should be trivial to patch
contravariant, distributive, exceptions, etc to depend on
transformers instead of this compat package.

How do you think?

Comment 2 Jens Petersen 2014-03-24 10:13:12 UTC
(In reply to Jens Petersen from comment #1)
> However I think (untested;) it should be trivial to patch
> contravariant, distributive, exceptions, etc to depend on
> transformers instead of this compat package.

For reference I attached a sample patch to bug 1075598 showing how
we could do this.

Comment 3 Rick Elrod 2014-03-26 01:38:30 UTC
Ok, we can patch instead. Closing this, then. :)

Comment 4 Jens Petersen 2014-07-05 06:02:28 UTC
Reopening, since contravariant-0.6 needs this with transformers-0.3.

Comment 5 Jens Petersen 2014-07-05 06:05:31 UTC
If Ricky if you want to update to 0.3.* I can review this.

Comment 6 Jens Petersen 2014-07-07 02:35:29 UTC
The best way to enable the three flag is to use run:

  cabal-tweak-flag three True

in %prep.  Failing that patching is also okay, but using cabal-tweak-flag
is much easier to maintain.

(What I said on irc about setting flags with %cabal_configure_options
or $cabal_configure_extra_options is suboptimal since it is
not visible to tools like cblrpm or cblrepo.)

Comment 8 Jens Petersen 2014-07-07 09:30:14 UTC
Package Review
==============
Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====
C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 9 files have unknown license. Detailed output of
     licensecheck in /home/petersen/pkgreview/1075595-ghc-transformers-
     compat/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 419840 bytes in 28 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Haskell:
[x]: This should never happen

===== SHOULD items =====
Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.

http://koji.fedoraproject.org/koji/taskinfo?taskID=7111201

[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====
Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.

Rpmlint
-------
Checking: ghc-transformers-compat-0.3.3.4-2.fc21.x86_64.rpm
          ghc-transformers-compat-devel-0.3.3.4-2.fc21.x86_64.rpm
          ghc-transformers-compat-0.3.3.4-2.fc21.src.rpm
ghc-transformers-compat.x86_64: E: summary-too-long C A small compatibility shim exposing the new types from transformers 0.3 and 0.4 to older Haskell platforms
ghc-transformers-compat.x86_64: W: spelling-error %description -l en_US backported -> back ported, back-ported, backpacked
ghc-transformers-compat.src: E: summary-too-long C A small compatibility shim exposing the new types from transformers 0.3 and 0.4 to older Haskell platforms
ghc-transformers-compat.src: W: spelling-error %description -l en_US backported -> back ported, back-ported, backpacked
3 packages and 0 specfiles checked; 2 errors, 2 warnings.

Rpmlint (installed packages)
----------------------------
# rpmlint ghc-transformers-compat-devel ghc-transformers-compat
ghc-transformers-compat.x86_64: E: summary-too-long C A small compatibility shim exposing the new types from transformers 0.3 and 0.4 to older Haskell platforms
ghc-transformers-compat.x86_64: W: spelling-error %description -l en_US backported -> back ported, back-ported, backpacked
2 packages and 0 specfiles checked; 1 errors, 1 warnings.
# echo 'rpmlint-done:'

Requires
--------
ghc-transformers-compat-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(transformers-compat-0.3.3.4-75e04eb8e5cb5d9583f1bf9de3f019a9)
    ghc-compiler
    ghc-devel(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc-devel(transformers-0.3.0.0-387c76a892254b0b8fe4d66f4780ad17)
    ghc-transformers-compat(x86-64)

ghc-transformers-compat (rpmlib, GLIBC filtered):
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc(transformers-0.3.0.0-387c76a892254b0b8fe4d66f4780ad17)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libHStransformers-0.3.0.0-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)

Provides
--------
ghc-transformers-compat-devel:
    ghc-devel(transformers-compat-0.3.3.4-75e04eb8e5cb5d9583f1bf9de3f019a9)
    ghc-transformers-compat-devel
    ghc-transformers-compat-devel(x86-64)
    ghc-transformers-compat-static

ghc-transformers-compat:
    ghc(transformers-compat-0.3.3.4-75e04eb8e5cb5d9583f1bf9de3f019a9)
    ghc-transformers-compat
    ghc-transformers-compat(x86-64)
    libHStransformers-compat-0.3.3.4-ghc7.6.3.so()(64bit)

Unversioned so-files
--------------------
ghc-transformers-compat: /usr/lib64/ghc-7.6.3/transformers-compat-0.3.3.4/libHStransformers-compat-0.3.3.4-ghc7.6.3.so

Source checksums
----------------
http://hackage.haskell.org/package/transformers-compat-0.3.3.4/transformers-compat-0.3.3.4.tar.gz :
  CHECKSUM(SHA256) this package     : 257712be0c2d5eedc6c835421751fce8daf45cf2687f2d6c27b92bff5e204bc1
  CHECKSUM(SHA256) upstream package : 257712be0c2d5eedc6c835421751fce8daf45cf2687f2d6c27b92bff5e204bc1

Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1075595
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Haskell, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


Package is APPROVED

I will attach a minor patch improving
the package summary and description.

Comment 9 Jens Petersen 2014-07-07 09:36:10 UTC
Created attachment 916004 [details]
ghc-transformers-compat.spec-1.patch

Comment 10 Rick Elrod 2014-07-07 15:37:59 UTC
New Package SCM Request
=======================
Package Name: ghc-transformers-compat
Short Description: A compatibility shim exposing the new types from transformers 0.3
Upstream URL: https://hackage.haskell.org/package/transformers-compat
Owners: codeblock petersen
Branches: f20 f19 epel7
InitialCC: haskell-sig

Comment 11 Gwyn Ciesla 2014-07-07 17:06:10 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2014-07-08 00:58:44 UTC
ghc-transformers-compat-0.3.3.4-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ghc-transformers-compat-0.3.3.4-2.fc20

Comment 13 Fedora Update System 2014-07-09 02:29:25 UTC
ghc-transformers-compat-0.3.3.4-2.fc20 has been pushed to the Fedora 20 testing repository.

Comment 14 Jens Petersen 2014-07-30 06:39:37 UTC
Ping? :)

Comment 15 Fedora Update System 2014-07-30 07:13:04 UTC
ghc-transformers-compat-0.3.3.4-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ghc-transformers-compat-0.3.3.4-2.fc19

Comment 16 Fedora Update System 2014-07-30 21:56:45 UTC
ghc-transformers-compat-0.3.3.4-2.fc20 has been pushed to the Fedora 20 stable repository.

Comment 17 Fedora Update System 2014-08-08 08:36:31 UTC
ghc-transformers-compat-0.3.3.4-2.fc19 has been pushed to the Fedora 19 stable repository.

Comment 18 Fedora Update System 2014-11-05 01:22:31 UTC
ghc-optparse-applicative-0.11.0.1-2.el7,ghc-transformers-compat-0.3.3.4-2.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/ghc-optparse-applicative-0.11.0.1-2.el7,ghc-transformers-compat-0.3.3.4-2.el7

Comment 19 Fedora Update System 2014-11-30 19:15:35 UTC
ghc-transformers-compat-0.3.3.4-2.el7, ghc-optparse-applicative-0.11.0.1-3.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.